# Generated automatically from Makefile.in by configure.
# Makefile.in for thttpd
#
# Copyright  1995,1998 by Jef Poskanzer <jef@acme.com>.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

include ${PLATFORM_ROOT}/build/Make.context
#include ${PLATFORM_ROOT}/fs/apps/Make.defs

CROSS = arm-uclinux-
CC = $(CROSS)gcc
AR = $(CROSS)ar
STRIP = $(CROSS)strip
LD = ldelf2flt

CFLAGS = -Wall -Os -D_GNU_SOURCE -mapcs-32 -mcpu=arm7tdmi  -msoft-float -fomit-frame-pointer -fpic -msingle-pic-base -mpic-register=10 -mno-got -fcall-saved-r10 -DNO_MM

LFLAGS=-s -Wl,-warn-common  --static -Wl,-T,/opt/Cadenux/dm270/uclinux-2.4/crossdev/arm-uclinux/lib/flat-user.ld -r -nostartfiles 

STARTUP=/opt/Cadenux/dm270/uclinux-2.4/crossdev/arm-uclinux/lib/crt0.o

LDFLAGS = -s 32768



############### MPH


CCOPT =		-O
DEFS =		 -DHAVE_FCNTL_H=1 -DHAVE_GRP_H=1 -DHAVE_MEMORY_H=1 -DHAVE_PATHS_H=1 -DHAVE_DIRENT_H=1 -DHAVE_STRERROR=1 -DHAVE_WAITPID=1 -DHAVE_VSNPRINTF=1 -DHAVE_SETSID=1 -DHAVE_GAI_STRERROR=1 -DHAVE_UNISTD_H=1 -DHAVE_GETPAGESIZE=1 -DHAVE_SELECT=1 -DHAVE_SOCKADDR_STORAGE=1 -DHAVE_SOCKADDR_IN6=1 -DSEC_PORT -DTIME_WITH_SYS_TIME=1 

INCLS =		-I. -I../../apps/cgi/libcgicomm/inc
# for more debug output, -DDEBUG
CFLAGS +=	$(CCOPT) $(DEFS) $(INCLS)
### Melinda add for testing ####
#CFLAGS +=	-DTESTING -DSIMU_TIME -DDEF_MPEG  
#CFLAGS +=	-DTESTING -DSKIP_T 
#CFLAGS +=	-DTESTING -DSIMU_DELAY 
#CFLAGS +=	-DSIMU_SENDTIME
#CFLAGS +=	-DSIMU_TIME  
#CFLAGS +=	-DDEF_MPEG  
#CFLAGS +=	-DTESTING1
CFLAGS +=	-DNewASF
################################


NETLIBS =	
INSTALL =	/usr/bin/install -c


.c.o:
	@rm -f $@
	$(CC) $(CFLAGS) -c $*.c

SRC =		thttpd.c libhttpd.c fdwatch.c mmc.c timers.c match.c tdate_parse.c syslog.c PRO_file.c des.c IMG_conf.c AUDIO_functions.c CMOS_functions.c SYS_log.c

OBJ =		$(SRC:.c=.o) 
#OBJ1= ../cgi/obj/PRO_file.o ../cgi/obj/des.o ../cgi/image/IMG_conf.o ../cgi/obj/AUDIO_functions.o ../cgi/obj/CMOS_functions.o ../cgi/obj/SYS_log.o

ALL =		thttpd

GENHDR =	mime_encodings.h mime_types.h

CLEANFILES =	$(ALL) $(OBJ) $(GENSRC) $(GENHDR) *.elf



all:		h-files this 
this:		$(ALL)

h-files:
	@echo "Creating Necessary Links ..."
	@rm -f AUDIO_commands.h AUDIO_functions.c CMOS_commands.h CMOS_functions.c IMG_conf.h IMG_conf.c PRO_file.c SYS_log.c
	@ln -sf ../../apps/cgi/libcgicomm/src/AUDIO/AUDIO_commands.h AUDIO_commands.h
	@ln -sf ../../apps/cgi/libcgicomm/src/AUDIO/AUDIO_functions.c AUDIO_functions.c
	@ln -sf ../../apps/cgi/libcgicomm/src/CMOS/CMOS_commands.h CMOS_commands.h
	@ln -sf ../../apps/cgi/libcgicomm/src/CMOS/CMOS_functions.c CMOS_functions.c
	@ln -sf ../../apps/cgi/libcgicomm/src/image/IMG_conf.c IMG_conf.c
	@ln -sf ../../apps/cgi/libcgicomm/src/profile/PRO_file.c PRO_file.c
	@ln -sf ../../apps/cgi/libcgicomm/src/syslog/SYS_log.c SYS_log.c

thttpd: $(OBJ) $(OBJ1) 
	$(CC) $(LFLAGS) -o $@.elf $(STARTUP) $^
	$(LD) $(LDFLAGS) -o $@ $@.elf

libhttpd.o:		mime_encodings.h
mime_encodings.h:	mime_encodings.txt
	rm -f mime_encodings.h
	sed < mime_encodings.txt > mime_encodings.h \
	  -e 's/#.*//' -e 's/[ 	]*$$//' -e '/^$$/d' \
	  -e 's/[ 	][ 	]*/", "/' -e 's/^/{ "/' -e 's/$$/" },/'

libhttpd.o:	mime_types.h
mime_types.h:	mime_types.txt
	rm -f mime_types.h
	sed < mime_types.txt > mime_types.h \
	  -e 's/#.*//' -e 's/[ 	]*$$//' -e '/^$$/d' \
	  -e 's/[ 	][ 	]*/", "/' -e 's/^/{ "/' -e 's/$$/" },/'


install:	installthis

installthis:
	$(INSTALL) -D --mode=0755 thttpd $(SBIN_DIR)/thttpd
	$(INSTALL) -D --mode=0644 thttpd.conf $(CGI_DIR)/thttpd.conf


clean:
	@rm -f AUDIO_commands.h AUDIO_functions.c CMOS_commands.h CMOS_functions.c IMG_conf.c PRO_file.c SYS_log.c
	rm -f $(CLEANFILES)

thttpd.o:	config.h version.h libhttpd.h fdwatch.h mmc.h timers.h match.h
libhttpd.o:	config.h version.h libhttpd.h mime_encodings.h mime_types.h \
		mmc.h timers.h match.h tdate_parse.h
fdwatch.o:	fdwatch.h
mmc.o:		mmc.h
timers.o:	timers.h
match.o:	match.h
tdate_parse.o:	tdate_parse.h
