
//------------------------------------------------------------------------
// Change log
// 
// 2002/10/21 Melinda
// Add code for video.asf
// 
// 2003/01/16 (Melinda)
// Add audio feature 
// 
// 2003/03/10 (Melinda)
// Add log message if dsp_srv is not loaded 
//------------------------------------------------------------------------

#ifdef NewASF
#define	DATA_HD_NO	4
//unsigned long D_seq=1;
ST_HD DataStreamingHD={0x4424,2008,0,0x0c00,2008};
ST_HD EndStreaming={0x4524,8,0,0x0c00,8};
#else
#define	DATA_HD_NO	3
#endif

typedef struct{
  ASF_ERROR_CORRECTION EC;
  ASF_PAYLOAD_INFORMATION PL_Info;
  Payload_flag  flag;
  //BYTE	Num	:6;	//number of payloads=2
  //BYTE	LenType	:2;	//10 (WORD)
}ASF_DATA_HEADER __attribute__((packed));

#define	VDeltaT		1000
#define	ADeltaT		80

#define MAX_DRV_BUSY_NO		1000
#define MAX_LAN_BUSY_NO		1000
#define	ReviseT		0	//millisecond
#ifdef TESTING
int StopImage=0;
int KeepLog=0;
#endif
#ifdef SKIP_T
#define	FRAME_SKIP	40
#define SkipT		20
#endif
#define DeltaT		50	//millisecond

#define ASF_DATA_HEADER_LEN	(ASF_ERROR_CORRECTION_LEN+ASF_PAYLOAD_INFORMATION_LEN+1)	//14

long MAX_DATA_PACKET_SIZE=2000;
#define MAX_I_DATA_SIZE		(MAX_DATA_PACKET_SIZE-31);
#define MAX_P_DATA_SIZE		(MAX_DATA_PACKET_SIZE-23);
//#define MAX_I_DATA_SIZE	(MAX_DATA_PACKET_SIZE-ASF_DATA_HEADER_LEN-IFrame_PayLoad_Len)	//MAX_DATA_PACKET_SIZE-31
//#define MAX_P_DATA_SIZE	(MAX_DATA_PACKET_SIZE-ASF_DATA_HEADER_LEN-PFrame_PayLoad_Len)	//MAX_DATA_PACKET_SIZE-23
IFrame_PayLoad asfI_Payload={
0x01,00,00000000,8,0,0,0
};
PFrame_PayLoad asfP_Payload={
0x01,0,00000000,0,0
};
static BYTE Pad[1977]; //2000-23

//static BYTE ErrData[4000];
//static BYTE ErrData[128];


#define HD_AUDIO_START	8
#define HD_AUDIO_NO	3
int  HD_BUF_NO=12;
int ASF_ALL_HEADER_LEN=ASF_ALL_HEADER_LEN_V;


hdbuf HD_buf[HD_BUF_NO0]={
{(BYTE *)&StreamHd,12},
{(BYTE *)&asfHeader,ASF_HEADER_LEN},
{(BYTE *)&asfFileProperty,ASF_FILE_PROPERTY_LEN-4},
{(BYTE *)0,4},

{(BYTE *)&asfVideoStreamProperty,ASF_VIDEO_STREAM_PROPERTY1_LEN}, //4
{(BYTE *)&asfVideoStreamProperty.videoMedia.m1,ASF_VIDEO_MEDIA1_LEN},
{(BYTE *)&asfVideoStreamProperty.videoMedia.m2,ASF_VIDEO_MEDIA2_LEN},
{(BYTE *)&asfVideoStreamProperty.videoMedia.mp4Header,ASF_MP4S_HEADER_LEN},

{(BYTE *)&asfAudioStreamProperty1,ASF_AUDIO_STREAM_PROPERTY1_LEN}, //8
{(BYTE *)&asfAudioStreamProperty2,ASF_AUDIO_STREAM_PROPERTY2_LEN},
{(BYTE *)&asfAudioStreamProperty3,ASF_AUDIO_STREAM_PROPERTY3_LEN},

{(BYTE *)&asfHeaderExtension,ASF_HEADER_EXTENSION_LEN},	//11
{(BYTE *)&asfData,ASF_DATA_LEN},
};

void set_data_header_iv(struct iovec iv[],httpd_conn*hc,int limit,int *no);
#ifdef TESTING
int my_writev(int fd, const struct iovec *vec, int no,char *s)
{
#ifdef SIMU_DELAY
   if(strcmp(s,"IMG")==0){ 
	ftime(&CurT);
	CurTime=(unsigned long)(CurT.time*1000+CurT.millitm);
	if (EnableDelay){
	   if(CurTime-PrevTime>=DELAY_TIME){
		//should start sending
		EnableDelay=0;
		PrevTime=CurTime;
		syslog(LOG_ERR,"Start sending...");
	   }
	   else
		return(0);
	}
	else{
	   if(CurTime-PrevTime>=SEND_TIME){
		//should stop sending
		EnableDelay=1;
		PrevTime=CurTime;
		syslog(LOG_ERR,"Halt sending...");
		return(0);
	   }
	}
   }
#endif
#ifndef DEF_MPEG
{
   int i;
   for(i=0;i<no;i++){
	if((unsigned long)vec[i].iov_base>=IMG_BUF_START)
	    continue;
	syslog(LOG_ERR,"%s - iv[%d].p=%lx len=%d",s,i,(unsigned long)vec[i].iov_base,vec[i].iov_len);
	sprintf(logmsg,"%s - iv[%d].p=%lx len=%d",s,i,(unsigned long)vec[i].iov_base,vec[i].iov_len);
	LogMsg(logmsg);
   }
}
#endif
   return(writev(fd,vec,no));
}
#endif
#ifdef TESTING1
void ClrLog(void)
{
   FILE *fh;
   fh=fopen("/tmp/asf.log","w");
   if(fh)
      fclose(fh);

}
void LogMsg(char *s)
{
   FILE *fh;
   struct stat st;
   time_t t;

   time(&t);
   stat("/tmp/asf.log",&st);
   if(st.st_size>20000)
	fh=fopen("/tmp/asf.log","w");
   else
   fh=fopen("/tmp/asf.log","a+");
   if(fh){
        fprintf(fh,"%s - %s\n",ctime(&t),s);
        fclose(fh);
   }
}
#endif
//Melinda add
void my_exit(int status)
{
#ifdef TESTING
   {
   time_t t;
   	sprintf(logmsg,"exit with status=%d errno=%d err=%s",status,errno,strerror(errno));
   	LogMsg(logmsg);

   	time(&t);
      	sprintf( logmsg, "%s", ctime(&t));
	LogMsg(logmsg);
	if(status==32){
	   switch(errno){
		case EBADF:
		  sprintf(logmsg,"errno=EBADF");
		  break;
		case EINVAL:
		  sprintf(logmsg,"errno=EINVAL");
		  break;
		case ENOMEM:
		  sprintf(logmsg,"errno=ENOMEM");
		  break;
		default:
		  sprintf(logmsg,"errno=Unknown");
	    }
	    LogMsg(logmsg);
        }
    }
#endif
        shut_down();
	//sprintf(logmsg,"thttpd exit with status=%d err=%s",status,strerror(errno));
   	//turn off led 2	(active LED)
	system("/usr/local/bin/do_leds 1 1 >/dev/null 2>/dev/null");

        if(status!=14 && status!=25) { //not normal exit or reentry
	  //act_v_drv();
	  system("/usr/local/bin/restart_webserver -nostop &"); 
	}
	exit(status);
}	
#define		ImgSize_640	0x0e1000	//640*480*(24/8)
#define		ImgSize_320	0x038400
#define		ImgSize_160	0x00f000	//160*128*3
//static WORD MyDuration=94;
//Comp: 1-Very High, 2-High, 3-Normal, 4-Low, 5-Very Low
void prepare_asf_header(unsigned short res,unsigned short Bitrate,unsigned short Comp,httpd_conn *hc)
{
 unsigned long t;
 int i,j,k;
 IMG_Conf conf;

 conf.en_a=0;
 IMG_GetConf(&conf);
 
 if(conf.en_a){ 
    IMG_AUD *a=0;

    hc->br=((DWORD)Bitrate+16)*1000; //Kbit
    //hc->br=((DWORD)Bitrate)*1000; //Kbit
    a=IMG_GetAudInfo();
    if (a){
    	asfAudioStreamProperty2.channelNum=a->numChannels;
	asfAudioStreamProperty2.samplesPerChannel=a->samplesPerSec;
	asfAudioStreamProperty2.bytesPerSecondWORD=a->bytesPerSec;
	asfAudioStreamProperty2.bitsPerSample=(DSP_BitR+2);
    }
    if(hc->is_mp9)
       HD_BUF_NO=HD_BUF_NO0;	//13
    else
       HD_BUF_NO=HD_BUF_NO0-1;	//12, skip StreamHd
    asfHeader.objectNum=4;
    ASF_ALL_HEADER_LEN=ASF_ALL_HEADER_LEN_AV;
 }
 else{
    hc->br=((DWORD)Bitrate)*1000; //Kbit
    if(hc->is_mp9)
       HD_BUF_NO=HD_BUF_NO0-3;	//10
    else
       HD_BUF_NO=HD_BUF_NO0-4;	//9, skip StreamHd
    asfHeader.objectNum=3;
    ASF_ALL_HEADER_LEN=ASF_ALL_HEADER_LEN_V;
 }
#ifdef TESTING
	sprintf(logmsg,"all_hd_len=%x \n",ASF_ALL_HEADER_LEN);
	LogMsg(logmsg);
#endif
asfHeader.objectLen=(ASF_ALL_HEADER_LEN);
#ifdef NewASF
 StreamHd.len=(ASF_ALL_HEADER_LEN+ASF_DATA_LEN+8);
 StreamHd.len2=StreamHd.len;
 if(hc->is_mp9){
    hc->asf.bytes=(ASF_ALL_HEADER_LEN+ASF_DATA_LEN+12);	//??+50
    hc->data_hd_len=(ASF_DATA_HEADER_LEN+12);
    asfFileProperty.fileLen=(ASF_ALL_HEADER_LEN+ASF_DATA_LEN);
 }
 else{
    hc->asf.bytes=(ASF_ALL_HEADER_LEN+ASF_DATA_LEN);	//??+50
    hc->data_hd_len=ASF_DATA_HEADER_LEN;
    asfFileProperty.fileLen=0xffffffff;
 }
#else
    hc->asf.bytes=(ASF_ALL_HEADER_LEN+ASF_DATA_LEN);	//??+50
    hc->data_hd_len=ASF_DATA_HEADER_LEN;
#endif
#ifdef TESTING
	sprintf(logmsg,"data_hd_len=%ld asf.bytes=%d\n",hc->data_hd_len,hc->asf.bytes);
	LogMsg(logmsg);
#endif
 asfFileProperty.maxBitrate=hc->br;
 switch(res){
   case IMG_RES_128:
     asfVideoStreamProperty.videoMedia.m1.encodedImageWidth=160;
     asfVideoStreamProperty.videoMedia.m1.encodedImageHeigh=128;
     asfVideoStreamProperty.videoMedia.m2.imageWidth=160;
     asfVideoStreamProperty.videoMedia.m2.imageHeigh=128;
     asfVideoStreamProperty.videoMedia.m2.imageSize=ImgSize_160;
     break;
   case IMG_RES_480:
     asfVideoStreamProperty.videoMedia.m1.encodedImageWidth=640;
     asfVideoStreamProperty.videoMedia.m1.encodedImageHeigh=480;
     asfVideoStreamProperty.videoMedia.m2.imageWidth=640;
     asfVideoStreamProperty.videoMedia.m2.imageHeigh=480;
     asfVideoStreamProperty.videoMedia.m2.imageSize=ImgSize_640;
     break;
   default:	// 320*240
     asfVideoStreamProperty.videoMedia.m1.encodedImageWidth=320;
     asfVideoStreamProperty.videoMedia.m1.encodedImageHeigh=240;
     asfVideoStreamProperty.videoMedia.m2.imageWidth=320;
     asfVideoStreamProperty.videoMedia.m2.imageHeigh=240;
     asfVideoStreamProperty.videoMedia.m2.imageSize=ImgSize_320;
     break;
 } 
#ifndef DEF_MPEG
 IMG_GetMP4Header((char *)&asfVideoStreamProperty.videoMedia.mp4Header);
#endif
 asfFileProperty.minDataPacketLen=MAX_DATA_PACKET_SIZE;
 asfFileProperty.maxDataPacketLen=MAX_DATA_PACKET_SIZE;
 t=(MAX_DATA_PACKET_SIZE<<3)*1000/hc->br; //minisecond
#ifdef NO_DURATION
 hc->duration=200;
#else
 hc->duration=(WORD)t;
#endif
#ifdef TESTING
   sprintf(logmsg,"Quality=%d MAX_DATA_PACKET_SIZE=%ld",Comp,MAX_DATA_PACKET_SIZE);
   LogMsg(logmsg);
   sprintf(logmsg,"HD_BUF_NO=%d ALL_HEADER_LEN=%d",HD_BUF_NO,ASF_ALL_HEADER_LEN);
   LogMsg(logmsg);
#endif
 if(hc->is_mp9){
	j=0;
	k=HD_AUDIO_START; 
 }
 else {
	j=1;	//skip StreamHd
	k=HD_AUDIO_START-1; 
 }
 for(i=0;i<HD_BUF_NO;i++){
   if(!conf.en_a && i>=k){
	//skip audio object
	hc->hd_buf[i].p=HD_buf[i+j+HD_AUDIO_NO].p;
	hc->hd_buf[i].len=HD_buf[i+j+HD_AUDIO_NO].len;
   }
   else{
	hc->hd_buf[i].p=HD_buf[i+j].p;
	hc->hd_buf[i].len=HD_buf[i+j].len;
   }
 }
 hc->hd_buf[3-j].p=(BYTE *)&hc->br;
   
}
//--------------------------------------------------------
// purpose: set payload information
// input: hc - connect info
//        i - the index of img
//        hd - ASF data header
//        base - base time
// NOTE: must set hc->data_pkt_size, hd->flag.Num and 
//       hc->img[i] before calling this routine
//--------------------------------------------------------
void set_payload(httpd_conn *hc,int i,ASF_DATA_HEADER *hd,unsigned long base)
{
   IMG_INFO *info;
   long max_size;
   IFrame_PayLoad *iframe=0;
   PFrame_PayLoad *pframe=0;
   img_info *img=(img_info *)&hc->img[i];
   BYTE StreamNum;	


   info=(IMG_INFO *)img->hd;
   max_size=MAX_DATA_PACKET_SIZE-hc->data_pkt_size;
   if(!hc->more_data_pkt ) {//First payload of frame
      img->first_iframe=1;
      max_size-=IFrame_PayLoad_Len;
   }
   else{
      img->first_iframe=0;
      max_size-=PFrame_PayLoad_Len;
   }
   //prepare payload
   img->payload.data=img->buf;
   if(img->first_iframe)  { // first payload

          iframe=&img->payload.hd.iframe;
          memcpy(iframe,&asfI_Payload,IFrame_PayLoad_Len);
	  if(info->i && info->a){
              if(img->bytes==400) //audio frame
		info->i=0;
	      else
		info->a=0;
	  }
	  if(info->a)
	      iframe->StreamNum=0x02;
	  if(info->i)
	      iframe->StreamNum|=0x80;
	  StreamNum=iframe->StreamNum;	  
          //iframe->MediaObjNum=img->frame_no;  
	  iframe->Offset=0;
	  iframe->FrameSize=img->bytes;
#ifdef SIMU_TIME
          iframe->PresentTime=img->t;
#else
#ifdef SKIP_T
	     if(info->video.Time>=base)
                iframe->PresentTime=info->video.Time-base;
	  else{
             	iframe->PresentTime=0xffffffff-base;
	     	iframe->PresentTime+=info->video.Time;
	     	iframe->PresentTime++;
	     }
	     if(hc->total_frame>FRAME_SKIP)
	        iframe->PresentTime-=SkipT;
	
#else	 //SKIP_T 
	     if(info->video.Time>=base)
                iframe->PresentTime=info->video.Time-base;
 	     else{
             	iframe->PresentTime=0xffffffff-base;
	     	iframe->PresentTime+=info->video.Time;
	     	iframe->PresentTime++;
	     }
#ifdef TESTING1
     if(hc->all_asf ){
	//syslog(LOG_ERR,"f_no=%d pt=%u a=%d i=%d t=%ld",hc->total_frame,iframe->PresentTime,info->a,info->i,info->video.Time);
//####
#if 0
	  { unsigned int f;
		if(iframe->PresentTime>=hc->prev_time)
		   f=iframe->PresentTime-hc->prev_time;
	 	else{
             	   f=0xffffffff-hc->prev_time;
             	   f+=iframe->PresentTime;
		   f++;
		}
	       	if(f>=1000){
		   sprintf(logmsg,"Frame_no=%d Diff Time=%u prev=%u cur=%u!",hc->total_frame,f,hc->prev_time,iframe->PresentTime);
		LogMsg(logmsg);
	        }
		hc->prev_time=iframe->PresentTime;
	  }
#else
	  if(info->video.Time<hc->prev_time){
		sprintf(logmsg,"f_no=%d pt=%u a=%d i=%d t=%ld prevt=%d",hc->total_frame,iframe->PresentTime,info->a,info->i,info->video.Time,hc->prev_time);
		LogMsg(logmsg);
	  }
	  hc->prev_time=info->video.Time;
#endif
     }//all_asf

#endif  //if TESTING
#endif	//else SKIP_T

#endif	//SIMU_TIME
   }
   else{
          pframe=&img->payload.hd.pframe;
          memcpy(pframe,&asfP_Payload,PFrame_PayLoad_Len);
	  if(info->a){
#ifdef TESTING
	       syslog(LOG_ERR,"AUDIO Frame has been separated audio_no=%d",hc->audio_no);
	       sprintf(logmsg,"Audio frame separated!! audio_no=%d bytes=%ld i=%d",hc->audio_no,img->bytes,info->i);
	       LogMsg(logmsg);	
#endif
	       info->a=0;		//Recover to correct value
	       pframe->StreamNum=0x01;
	  }
	  if(info->i)
	     pframe->StreamNum|=0x80;
 	  
	  StreamNum=pframe->StreamNum;	  
          //pframe->MediaObjNum=img->frame_no;  
	  pframe->Offset=img->total_offset;
   }
   hd->flag.Num+=1;	  //number of payloads
   if(img->bytes>=max_size){
	//must send image by several data packets
#ifdef TESTING
	if(info->a){
	   sprintf(logmsg," ->Error: Audio size=%ld max_sz=%ld audio_no=%d i=%d",img->bytes,max_size,hc->audio_no,info->i);
       	   LogMsg(logmsg);	
	}
#endif
	hd->PL_Info.paddingLength=0;
        if(img->first_iframe)   
	  iframe->Len=max_size;
        else
	  pframe->Len=max_size;
   	if(img->bytes>max_size){
   	   img->next_pk_offset=max_size;
	   hc->more_data_pkt=1;
        }
	else
	   hc->more_data_pkt=0;
	hc->data_pkt_size=MAX_DATA_PACKET_SIZE;
        
   } 
   else{ //image buffer can put in this data packet
        if(img->first_iframe) { 
	  iframe->Len=(WORD)img->bytes;
	  hc->data_pkt_size+=IFrame_PayLoad_Len; 
	}
        else{
	  pframe->Len=img->bytes;
	  hc->data_pkt_size+=PFrame_PayLoad_Len; 
	}
	hc->data_pkt_size+=img->bytes; 
	hc->more_data_pkt=0;
   }
   //copy payload header to dupmem to fix padding problem
   if(img->first_iframe){
	//memcpy(img->payload.dupmem,&iframe->StreamNum,1);
	//memcpy(img->payload.dupmem+1,&iframe->MediaObjNum,1);
	memcpy(img->payload.dupmem+2,&iframe->Offset,4);
	memcpy(img->payload.dupmem+6,&iframe->RepDataLen,1);
	memcpy(img->payload.dupmem+7,&iframe->FrameSize,10);
   }
   else{
	//memcpy(img->payload.dupmem,&pframe->StreamNum,1);
	//memcpy(img->payload.dupmem+1,&pframe->MediaObjNum,1);
	memcpy(img->payload.dupmem+2,&pframe->Offset,4);
	memcpy(img->payload.dupmem+6,&pframe->RepDataLen,1);
	memcpy(img->payload.dupmem+7,&pframe->Len,2);
   }
   {
     	unsigned short p0;
       	p0=(img->frame_no<<8)|StreamNum;
	memcpy(img->payload.dupmem,&p0,2);
#if 0
	sprintf(logmsg,"Payload (f_no+strNo)=%04x f_no=%d i=%d a=%d",p0,hc->total_frame,info->i,info->a);
	LogMsg(logmsg);
#endif

   }
}
#ifdef TESTING
void dump_data_packet(httpd_conn *hc)
{
#if 0
   ASF_DATA_HEADER *hd=(ASF_DATA_HEADER *)hc->data_hd;
   int i;
   img_info *img=0;
 
   LogMsg("\n---------------Dump Data Packet---------------"); 
   sprintf(logmsg,"PkgSize=%ld Account=%d FrameNo=%d total_img=%d more_pkt=%d",
   hc->data_pkt_size,hc->account,(int)hc->frame_no,hc->total_img,hc->more_data_pkt);
   LogMsg(logmsg);
#ifndef DEF_MPEG
   //dump data packet header
   sprintf(logmsg,"PadLen=%d SendTime=%lx Duration=%d PayloadNum=%d (%x) LenType=%x base_time=%lx",hd->PL_Info.paddingLength,(unsigned long)hd->PL_Info.sendTime,(int)hd->PL_Info.duration,(int)hd->flag.Num,(int)hd->flag.Num,(int)hd->flag.LenType,hc->base_time);
   LogMsg(logmsg);

   //dump img info
   for(i=0;i<hc->total_img;i++){
      VIDEO *v;
      sprintf(logmsg,"\nImage %d information:",i);
      LogMsg(logmsg); 
      img=&hc->img[i];
      v=(VIDEO *)img->hd;
      sprintf(logmsg,"  CurTime=%lx hd=%lX buf=%lX index=%d bytes=%ld next_offset=%lx first_iframe=%d frame_no=%d total_offset=%lx",v->Time,(unsigned long)img->hd,(unsigned long)img->buf,img->index, img->bytes,img->next_pk_offset,img->first_iframe,(int)img->frame_no,img->total_offset);
      LogMsg(logmsg);
      if(img->first_iframe){
        IFrame_PayLoad *ifr;
        ifr=&img->payload.hd.iframe;
	sprintf(logmsg,"  MediaObjNum=%x Offset=%x FrameSize=%x PresentT=%x Len=%x PayloadData=%lx",ifr->MediaObjNum,ifr->Offset,ifr->FrameSize,ifr->PresentTime,ifr->Len,(unsigned long)img->payload.data);
	LogMsg(logmsg);
      }
      else{
        PFrame_PayLoad *ifr;
        ifr=&img->payload.hd.pframe;
	sprintf(logmsg,"  MediaObjNum=%x Offset=%x Len=%x PayloadData=%lx",ifr->MediaObjNum,ifr->Offset,ifr->Len,(unsigned long)img->payload.data);
	LogMsg(logmsg);
      }	
   }
#endif
#endif
}
#endif
int chk_buf_size(img_info *img,int account,httpd_conn *hc)
{

   if(img->bytes==0){
#ifdef LOG_BUF
      LogMsg("========>> buffer size==0 !!!");
#endif
#ifndef DEF_MPEG
      if(StopAsf!=2)	
         IMG_ReleaseImg(img->index, account);  
#ifdef LOG_BUF
	sprintf(logmsg,"Release buffer index=%d account=%d addr=%lX",img->index,account,(unsigned long)img->hd);	
	LogMsg(logmsg);
#endif
#endif
      img->hd=0;
      img->buf=0;
      img->bytes=0;
      img->total_offset=0;
      img->next_pk_offset=0;
      img->index=-1; 
      hc->drv_busy++; 	
      return(1);
   }
   return(0);
}
#ifdef DEF_MPEG
int random_number=0;
#if 1	//320*240 Inginent I frame
#define DefBufNo	2
img_info def_buf[DefBufNo]=
{{(char *)0x4b0000,0,0,3945,}, 	//size must -20 bytes header
 {(char *)0x4c0000,0,1,3510,},
};
#else	//video pframe + 2 audio 320*240 
#define DefBufNo	3
img_info def_buf[DefBufNo]=
{{(char *)0x23f0000,0,0,3539,},
 {(char *)0x23f4000,0,1,320,},
 {(char *)0x23f8000,0,2,320,},
};
#endif
void My_get_image(img_info *img,httpd_conn *hc)
{
    int i=0;

    if(hc->account==-1)
        goto first_img;
    random_number++;
#if 0
    if((random_number%7)==0){ //simulate can't get img buffer
        //syslog(LOG_ERR,"BUSY, can't get image buffer!!! current frame_no=%d",hc->frame_no);
	img->hd=0;
	img->bytes=0;
	return;
    }
#endif 
first_img:    
    if(random_number%DefBufNo)
 	i=1;
    else
	i=0;
#ifdef LOG_BUF
    sprintf(logmsg,"Frame_no=%02d, get frame index %d len=%lx",hc->frame_no,i,def_buf[i].bytes); 
    LogMsg(logmsg);
#endif
    
    img->hd=def_buf[i].hd;
    img->bytes=def_buf[i].bytes;
    img->index=def_buf[i].index;
    hc->account=1;
#if LOG_BUF 
      sprintf(logmsg,"Get image index=%d size=%ld buf=%X",img->index,img->bytes,(int)img->hd);
      LogMsg(logmsg);
#endif
}
#endif
#if 0
void dump_ec(char *s,httpd_conn *hc)
{
    int cnum;
    ASF_DATA_HEADER *hd=0;
    for ( cnum = 0; cnum < maxconnects; ++cnum )
    {
	if ( connects[cnum].hc != (httpd_conn*) 0 ){
    	    hd=(ASF_DATA_HEADER *)connects[cnum].hc->data_hd;
	    if(!hd) continue;
	    if(hd->EC.dataLength!=2){
		KeepLog=1;
	        EC_chg[cnum]=1;
		sprintf(logmsg,"==>%s: conn[%d].hd.EC.dataLength=%d !=2 addr=%lx,hd=%lx",s,cnum,hd->EC.dataLength,(unsigned long)&hd->EC,(unsigned long)hd);
		LogMsg(logmsg);
	    }
	    else{
		if(EC_chg[cnum]==1){
		    sprintf(logmsg,"%s: conn[%d].hd.EC.dataLength is recoverd hd=%lx",s,cnum,(unsigned long)hd);
		    LogMsg(logmsg);
		    EC_chg[cnum]=0;
		}
	    }
	}
    }
}
#endif
int prepare_data_packet(struct iovec iv[],httpd_conn *hc,int limit,int *no)
{
   IMG_INFO *info;
   ASF_DATA_HEADER *hd;
#ifndef NewASF
   int i;
   img_info *img=0;
#endif
   unsigned long base=0;

   if(!hc->data_hd){
      hc->data_hd=malloc(sizeof(ASF_DATA_HEADER));      
      if(hc->data_hd==0){
#ifdef TESTING
	LogMsg("Can't allocate ASF data header, wait next time!");
#endif
         return(1);
      }
      hd=(ASF_DATA_HEADER *)hc->data_hd;
      memcpy(&hd->EC,&asfErrorCorrection,ASF_ERROR_CORRECTION_LEN);
      memcpy(&hd->PL_Info,&asfPayloadInfo,ASF_PAYLOAD_INFORMATION_LEN);
   }
   else
      hd=(ASF_DATA_HEADER *)hc->data_hd;
   //Need to fill send time, duration, and padding length...
   info=(IMG_INFO *)hc->img[0].hd;
#ifdef SIMU_TIME 
   hd->PL_Info.sendTime=hc->img[0].t;
#else
   base=hc->base_time; 
#ifdef SKIP_T
	if(info->video.Time>=base)
	      hd->PL_Info.sendTime=info->video.Time-base;
	else{
	       hd->PL_Info.sendTime=0xffffffff-base;
	       hd->PL_Info.sendTime+=info->video.Time;
	       hd->PL_Info.sendTime++;
	}
   	if(hc->total_frame>FRAME_SKIP)
	   hd->PL_Info.sendTime-=SkipT;
#else //SKIP_T
   if(hc->revise_base_time)
      base+=ReviseT;
   if(info->video.Time>=base)
       hd->PL_Info.sendTime=info->video.Time-base;
   else{
       hd->PL_Info.sendTime=0xffffffff-base;
       hd->PL_Info.sendTime+=info->video.Time;
       hd->PL_Info.sendTime++;
#ifdef TESTING
	sprintf(logmsg,"Wrap SendTime: baseT=%lx CurT=%lx SendT=%x",hc->base_time,info->video.Time,hd->PL_Info.duration);
	LogMsg(logmsg);
#endif
   }
 #if SIMU_SENDTIME
     hd->PL_Info.sendTime=0;
 #endif //SIMU_SENDTIME
#endif	//SKIP_T
#endif	//SIMU_TIME
   hd->PL_Info.duration=hc->duration; 
#ifdef NewASF
   hd->PL_Info.duration=3; 
#endif

   hd->flag.Num=0;
   hc->data_pkt_size=ASF_DATA_HEADER_LEN;
   set_payload(hc,0,hd,base);
   if (hc->data_pkt_size>=MAX_DATA_PACKET_SIZE)
	goto send_out;
   else{ 
#ifdef NewASF	//one payload in one data packet
	   hd->PL_Info.paddingLength=MAX_DATA_PACKET_SIZE-hc->data_pkt_size;
	   hc->data_pkt_size=MAX_DATA_PACKET_SIZE;
#ifdef TESTING
	   if(hc->total_frame>=hc->limit_frame){
		StopImage=1;
	   }
#endif
#else
        i=1;	//point to next index of img[]
        while ((i<MAX_IMG_BUF) && ((MAX_DATA_PACKET_SIZE-hc->data_pkt_size)>(IFrame_PayLoad_Len+16)) ) {
	   //have space to get next image buffer
#ifdef TESTING
	   if(hc->total_frame>=hc->limit_frame){
		StopImage=1;
	        break;
	   }
#endif
	   
           img=&hc->img[i];
#ifdef DEF_MPEG
	   My_get_image(img,hc);
#else
      	   img->hd = IMG_GetImg(&img->bytes, &img->index, hc->account);
#endif
	   if(img->hd==0){
#ifdef LOG_BUF
	     	{
		long pad;
	        pad=MAX_DATA_PACKET_SIZE-hc->data_pkt_size;
	        sprintf(logmsg,"BUSY=>frame_no=%d send data with padding len=%lx",hc->frame_no,pad);
	        LogMsg(logmsg);
		}
#endif	
	      hc->drv_busy++;	
	      break;	//can't get buffer just send out 
           }
	   if(chk_buf_size(img,hc->account,hc))
	      break;	//invalid buffer size
	   hc->drv_busy=0;
	   info=(IMG_INFO *)img->hd;
#if 0
	   hc->v_no++;
	   if(hc->v_no!=info->video.Quality){
		sprintf(logmsg,"!!!==>Error: v_no=%d Quality=%d",hc->v_no,info->video.Quality);
		LogMsg(logmsg);
		hc->v_no=info->video.Quality;
	   }
#endif
	   img->buf=img->hd+IMG_HD_SIZE;
      	   img->next_pk_offset=0;
      	   img->total_offset=0;
	   if(info->a){
	       img->frame_no=hc->audio_no;
	       hc->audio_no++;
	   }
	   else {
	       img->frame_no=hc->frame_no;
	       hc->frame_no++;
	   }
#ifdef SIMU_TIME
   	   if(hc->total_frame>0){
		if(info->a){
		   hc->a_time+=ADeltaT;
		   img->t=hc->a_time;
		}	        
		else{
		   hc->v_time+=VDeltaT;
		   if (hc->v_time<hc->a_time){
			hc->v_time=hc->a_time;
		   } 
		   img->t=hc->v_time; 
		}
	   }
     	   else
		img->t=0;
#endif
	   hc->total_frame++;
#ifdef SKIP_T
   	   base=hc->base_time; 
#else
           hc->revise_base_time=1;
	   base+=ReviseT;	//revise 10 milisecond
#endif
      	   hc->total_img++;
#ifdef LOG_BUF
	   sprintf(logmsg,"Get image index=%d size=%ld buf=%X a=%d i=%d",img->index,img->bytes,(int)img->hd,info->a,info->i);
	   LogMsg(logmsg);
	   
	   syslog(LOG_ERR,"i=%d img->frame_no=%d hc->frame_no=%d audio=%d if=%d",i,img->frame_no,hc->frame_no,info->a,info->i);
#endif
           if (info->a && (MAX_DATA_PACKET_SIZE-hc->data_pkt_size)<(IFrame_PayLoad_Len+img->bytes))  { //audio frame can't be separate
   		hc->audio_frame=1;
#ifdef LOG_BUF
	 	sprintf(logmsg,"data_pkt_size=%ld next audio_sz=%ld",hc->data_pkt_size,img->bytes);
		LogMsg(logmsg);
#endif
		break;
	   }
	   set_payload(hc,i,hd,base);
	   i++;
	
        } //while
	if(hc->data_pkt_size<MAX_DATA_PACKET_SIZE){
	   hd->PL_Info.paddingLength=MAX_DATA_PACKET_SIZE-hc->data_pkt_size;
	   hc->data_pkt_size=MAX_DATA_PACKET_SIZE;
        }
#endif	//NewASF
   } 
send_out:
   hc->packet_ready=1;
   set_data_header_iv(iv,hc,limit,no);
#ifdef TESTING
   dump_data_packet(hc);
#endif
   return(0);
}
#ifdef TESTING
void dump_asf_header(void)
{
        unsigned short *p,p1;
	LogMsg("Dump ASF HEADER--------");
	sprintf(logmsg,"VideoMedia formatDatalen(word)=%04x",(int)asfVideoStreamProperty.videoMedia.m1.formatDatalen);
	LogMsg(logmsg);
	p=(unsigned short *)&asfVideoStreamProperty.videoMedia.m1.formatDatalen;
	p1=(*p &0xff00)>>8;
        sprintf(logmsg,"dump memory= %x %x",(*p &0x00ff),p1);
	LogMsg(logmsg);
}
#endif
static int fill_asf_header(httpd_conn *hc)
{
   IMG_VID *v;

   v=IMG_GetVidInfo();
#ifdef TESTING
   sprintf(logmsg,"Bitrate=%d K",v->BitRate);
   LogMsg(logmsg);	
#endif
   prepare_asf_header(v->Res,v->BitRate,v->Comp,hc);
   //memset(ErrData,0x22,sizeof(ErrData));
   return(0);
}
static void set_asf_hd_package(struct iovec iv[],int i,int *no,hd_info *asf,hdbuf hd_buf[])
{
   int j,len,k,n;

   len=asf->bytes_sent;	
   for(k=0;k<HD_BUF_NO;k++){
	if(len<hd_buf[k].len)
	   break;
	len-=hd_buf[k].len;
	
   }
   for(n=0,j=k;j<HD_BUF_NO;j++,n++){
	if(j==k){
  	  iv[i+n].iov_base = (void *)(hd_buf[j].p+len);
	  iv[i+n].iov_len = (size_t)hd_buf[j].len-len;
	}
	else{
  	  iv[i+n].iov_base = (void *)hd_buf[j].p;
	  iv[i+n].iov_len = (size_t)hd_buf[j].len;
	}
   }
   *no=n;	
      
      
}
void free_data_packet(httpd_conn *hc)
{
   int i;

   for(i=0;i<hc->total_img;i++){
      if(i==(hc->total_img-1) && (hc->more_data_pkt || hc->audio_frame)){
	break;
      }
#ifndef DEF_MPEG
      if(StopAsf!=2)	
        IMG_ReleaseImg(hc->img[i].index, hc->account);  
#ifdef LOG_BUF
	sprintf(logmsg,"Release buffer index=%d account=%d addr=%lX",hc->img[i].index,hc->account,(unsigned long)hc->img[i].hd);	
	LogMsg(logmsg);
#endif
#endif
      hc->img[i].hd=0;
      hc->img[i].buf=0;
      hc->img[i].bytes=0;
      hc->img[i].total_offset=0;
      hc->img[i].next_pk_offset=0;
      hc->img[i].index=-1; 
   }
   if(hc->more_data_pkt || hc->audio_frame){
#if 0
	sprintf(logmsg,"Before memcpy: total_img=%d img->frame_no=%d",hc->total_img,hc->img[hc->total_img-1].frame_no);
	LogMsg(logmsg);
#endif	
	
      if(hc->total_img>1)
         memcpy(&hc->img[0],&hc->img[hc->total_img-1],sizeof(hc->img[0]));

#if 0
	sprintf(logmsg,"After memcpy: img[0].frame_no=%d",hc->img[0].frame_no);
	LogMsg(logmsg);
#endif	
#ifdef LOG_BUF
	sprintf(logmsg,"Already send %lx bytes total=%ld %lx",hc->img[0].next_pk_offset,hc->img[0].bytes,hc->img[0].bytes);
	LogMsg(logmsg);
#endif
      hc->img[0].buf+=hc->img[0].next_pk_offset;
      hc->img[0].bytes-=hc->img[0].next_pk_offset;
      hc->img[0].total_offset+=hc->img[0].next_pk_offset;
      hc->img[0].next_pk_offset=0;
      hc->img_bytes_sent=0;
      hc->total_img=1;
      hc->packet_ready=0;
      hc->audio_frame=0;	
      //wait next time to prepare data packet
#ifdef LOG_BUF
	sprintf(logmsg,"Still have %ld %lx bytes",hc->img[0].bytes,hc->img[0].bytes);
	LogMsg(logmsg);
#endif


   }
   else{
      hc->img_bytes_sent=0;
      hc->packet_ready=0;
      hc->total_img=0;
      hc->data_pkt_size=0;
   }
}
// set data packet header to iv[]
void set_data_header_iv(struct iovec iv[],httpd_conn*hc,int limit,int *no)
{
   int j,len,k,n;
   ASF_DATA_HEADER *hd;
   hdbuf data_obj[DATA_HD_NO]={
#ifdef NewASF
	{(BYTE *)&DataStreamingHD,12},
#endif   	
	{(BYTE *)&asfErrorCorrection,ASF_ERROR_CORRECTION_LEN},
	{(BYTE *)&asfPayloadInfo,ASF_PAYLOAD_INFORMATION_LEN},
	{0,1},
   };

#ifdef NewASF
	k=1;
	//must include DataStreamingHD in each hc->data_hd
#else
	k=0;
#endif
   hd=(ASF_DATA_HEADER *)hc->data_hd;
   data_obj[0+k].p=(BYTE *)&hd->EC;
   data_obj[1+k].p=(BYTE *)&hd->PL_Info;
   hd->flag.LenType=2;	//word
   data_obj[2+k].p=(BYTE *)&hd->flag;
   
   
   len=hc->img_bytes_sent;	
#ifdef NewASF
   if(hc->is_mp9)
	k=0;
   else
	k=1;
#else
	k=0;
#endif
   for(;k<DATA_HD_NO;k++){
	if(len<data_obj[k].len)
	   break;
	len-=data_obj[k].len;
	
   }
   for(n=0,j=k;j<DATA_HD_NO;j++,n++){
	if(j==k){
  	  iv[n].iov_base = (void *)(data_obj[j].p+len);
	  iv[n].iov_len = (size_t)data_obj[j].len-len;
	}
	else{
  	  iv[n].iov_base = (void *)data_obj[j].p;
	  iv[n].iov_len = (size_t)data_obj[j].len;
	}
   }
   *no=n;	
}
//set payload data to iv[]
void set_payload_iv(struct iovec iv[],httpd_conn *hc,int limit,int *no)
{
   long size,offset,hd_size=0;
   int i,j,k,last_img;
   img_info *img=0;
   ASF_DATA_HEADER *hd=(ASF_DATA_HEADER *)hc->data_hd;

   offset=hc->img_bytes_sent-hc->data_hd_len;
#ifdef NewASF
   if(hc->is_mp9)
      size=MIN( hc->data_pkt_size+12- hc->img_bytes_sent, limit);
   else
      size=MIN( hc->data_pkt_size- hc->img_bytes_sent, limit);
#else
   size=MIN( hc->data_pkt_size - hc->img_bytes_sent, limit);
#endif
   for(i=0;i<hc->total_img;i++){
       if(hc->img[i].first_iframe)
	  hd_size=IFrame_PayLoad_Len;
       else
	  hd_size=PFrame_PayLoad_Len;	
       if((hc->img[i].bytes+hd_size)>offset)
	  break;
       offset-=(hc->img[i].bytes+hd_size);
   }
   //we should send data from ith image buffer

   //------- FIX BUG: Bad stream number ------
   if( hc->audio_frame)
      last_img=hc->total_img-1;
   else 
      last_img=hc->total_img;

   for(j=i,k=0;j<last_img;j++,k++){
      img=(img_info *)&hc->img[j];
      if(j==i){
	  if(offset<hd_size){
	     //send from payload frame header
  	     iv[k].iov_base = (void *)((&img->payload.dupmem)+offset);
	     iv[k].iov_len = (size_t)(hd_size-offset);
#ifndef DEF_MPEG
#if 0
   if(i==0 && hc->img[i].first_iframe){
        char tmp[10];
  	unsigned short *p;
        BYTE  p1;
	int x;
	IFrame_PayLoad * f;

        f=(IFrame_PayLoad *)&img->payload.hd.iframe;
	LogMsg("===>Send first iframe");
	sprintf(logmsg,"size=%ld offset=%lx start addr=%lx,len=%d",size,offset,(unsigned long)iv[k].iov_base,IFrame_PayLoad_Len);
	LogMsg(logmsg);
#if 0
        sprintf(logmsg,"sizeof StreamNum=%d (b) MediaObjNum=%d (b) Offset=%d (dw) RepDataLen=%d (b) FrameS=%d (dw) PrenT=%d (dw) Len=%d (w)",sizeof(f->StreamNum),sizeof(f->MediaObjNum),sizeof(f->Offset),sizeof(f->RepDataLen),sizeof(f->FrameSize),sizeof(f->PresentTime),sizeof(f->Len));
	LogMsg(logmsg);
 	sprintf(logmsg,"Sizeof IFrame_PayLoad=%d (17)",sizeof(img->payload.hd.iframe));
	LogMsg(logmsg);
#endif
	sprintf(logmsg,"Sizeof dupmem=%d (17)",sizeof(img->payload.dupmem));
        p=(unsigned short *)iv[k].iov_base;
	strcpy(logmsg,"");
	for(x=0;x<25;x+=2,p++){
	   p1=((*p & 0xff00)>>8);
	   sprintf(tmp,"%02x %02x ",(*p &0x00ff),p1);
 	   strcat(logmsg,tmp);	   
	}
	LogMsg(logmsg);
   }
#endif
#endif

	     //check if the last iv
      	     if(size<=iv[k].iov_len){ //last iv
		  iv[k].iov_len=size;
		  k++;
	  	  size=0;
	          break; 
	     }  
	     else
		  size-=iv[k].iov_len;

	     k++; 	//next iv => payload data
  	     iv[k].iov_base = (void *)(img->payload.data);
	     if(img->first_iframe)
   	        iv[k].iov_len = (size_t)(img->payload.hd.iframe.Len);
	     else
   	        iv[k].iov_len = (size_t)(img->payload.hd.pframe.Len);

	  }
	  else{  //send from payload data
	     offset-=hd_size;
  	     iv[k].iov_base = (void *)(img->payload.data+offset);
	     if(img->first_iframe)
   	        iv[k].iov_len = (size_t)(img->payload.hd.iframe.Len-offset);
	     else
   	        iv[k].iov_len = (size_t)(img->payload.hd.pframe.Len-offset);
	  }
      }
      else{ //not first iv
         //set payload frame header
  	 iv[k].iov_base = (void *)(&img->payload.dupmem);
     	 if(img->first_iframe){
	    iv[k].iov_len=(size_t)IFrame_PayLoad_Len;
	 }
	 else{
	    iv[k].iov_len=(size_t)PFrame_PayLoad_Len;
	 }

	 //check if the last iv
      	 if(size<=iv[k].iov_len){ //last iv
	    iv[k].iov_len=size;
	    k++;
	    size=0;
	    break; 
	 }  
	 else
	    size-=iv[k].iov_len;

	 k++; 	//next iv => payload data
  	 iv[k].iov_base = (void *)(img->payload.data);
	 if(img->first_iframe)
   	    iv[k].iov_len = (size_t)(img->payload.hd.iframe.Len);
	 else
   	    iv[k].iov_len = (size_t)(img->payload.hd.pframe.Len);
      }
      //check if the last iv	
      if(size<=iv[k].iov_len){ //last iv
	  iv[k].iov_len=size;
	  k++;
	  size=0;
          break; 
      }  
      else	
         size-=iv[k].iov_len;
   }
   if(size>0) {//send padding data
      iv[k].iov_len=(size_t)hd->PL_Info.paddingLength;
      iv[k].iov_base=Pad;
      if(size!=iv[k].iov_len){
#ifdef TESTING
	sprintf(logmsg,"SIZE_NOT_MATCH ===> padding len=%d size=%ld",iv[k].iov_len,size);
	LogMsg(logmsg);
	syslog(LOG_ERR,"SIZE_NOT_MATCH ===> padding len=%d size=%ld\n",iv[k].iov_len,size);
#endif
      }	
      k++;
   }
   *no=k;
}
static int set_buf_package(struct iovec iv[],httpd_conn *hc,int limit,int *no)
{
   img_info *img;
   IMG_INFO *info;
   VIDEO *v;	
   long  data_bytes;

   if(hc->account==-1){
     
#ifdef SIMU_DELAY
	ftime(&CurT);
	PrevTime=(unsigned long)(CurT.time*1000+CurT.millitm);
	EnableDelay=0;
	syslog(LOG_ERR,"SEND_TIME=%d DELAY_TIME=%d",SEND_TIME,DELAY_TIME);
#endif
      hc->asf.bytes_sent=0;	
#ifndef DEF_MPEG
      hc->account = IMG_open_acnt(hc->conn_fd);
      if(hc->account==-1) {	//dsp_srv is not ready
          AddLog("thttpd",SYSLOG_NORMAL,3);
   	  return(-1);
      }
#endif
       memset(Pad,0,sizeof(Pad));
#if 0
       if(!KeepLog)	
           ClrLog();	
#endif
   }
	
   img=&hc->img[0];

   if(img->hd==0){
#ifdef DEF_MPEG
	My_get_image(img,hc);
#else
      img->hd = IMG_GetImg(&img->bytes, &img->index, hc->account);
#endif
#ifdef LOG_BUF
      info=(IMG_INFO *)img->hd;
      sprintf(logmsg,"get image index=%d size=%ld buf=%X a=%d i=%d",img->index,img->bytes,(int)img->hd,info->a,info->i);
      LogMsg(logmsg);
#endif
      if(img->hd==0){
	 hc->drv_busy++;	
         return(1);
      } 
      if(chk_buf_size(img,hc->account,hc))
         return(3);	//invalid buffer size
      info=(IMG_INFO *)img->hd;
#if 0
      if(hc->total_frame==0) {
	 hc->v_no=info->video.Quality;
	 sprintf(logmsg,"First v_no=%d",hc->v_no);
	 LogMsg(logmsg);
      }	
      else {	
	 hc->v_no++;
	   if(hc->v_no!=info->video.Quality){
		sprintf(logmsg,"!!!==>Error: v_no=%d Quality=%d",hc->v_no,info->video.Quality);
		LogMsg(logmsg);
		hc->v_no=info->video.Quality;
	   }
      }
#endif
      hc->drv_busy=0;
      img->buf=img->hd+IMG_HD_SIZE;
      img->next_pk_offset=0;
      img->total_offset=0;
      hc->img_bytes_sent=0;
      hc->total_img=1;
      if(info->a){
         img->frame_no=hc->audio_no;	
      	 hc->audio_no++;
      }
      else{
         img->frame_no=hc->frame_no;	
      	 hc->frame_no++;
      }	
#ifdef SIMU_TIME
     if(hc->total_frame>0){
		if(info->a){
		   hc->a_time+=ADeltaT;
		   img->t=hc->a_time;
		}	        
		else{
		   hc->v_time+=VDeltaT;
		   if (hc->v_time<hc->a_time)
			hc->v_time=hc->a_time;
		   img->t=hc->v_time; 
		}
     }
     else
	img->t=0;
#endif
      hc->total_frame++;
      hc->packet_ready=0;
      if(hc->total_frame==1){ //first buffer
        info=(IMG_INFO *)hc->img[0].hd;
        v=&info->video;
        hc->base_time=v->Time;
#ifdef TESTING
	sprintf(logmsg,"base_time=%lx %lu",v->Time,v->Time);
	LogMsg(logmsg);
#endif
       }
       else {	
#ifndef SKIP_T
      hc->revise_base_time=1;
#endif
       }
#ifdef LOG_BUF
       {
	   syslog(LOG_ERR,"i=%d img->frame_no=%d hc->frame_no=%d",0,img->frame_no,hc->frame_no);
       }
#endif
   }
   if(hc->img_bytes_sent<hc->data_hd_len){
      if(hc->packet_ready)
         set_data_header_iv(iv,hc,limit,no);
      else
         return(prepare_data_packet(iv,hc,limit,no));
   }
   else{
#ifdef NewASF
      if(hc->is_mp9)
	data_bytes=hc->data_pkt_size+12;
      else
	data_bytes=hc->data_pkt_size;
#else
	data_bytes=hc->data_pkt_size;
#endif


      if(hc->img_bytes_sent>=data_bytes){
	 free_data_packet(hc);
	 return(2);
      }
      else
         set_payload_iv(iv,hc,limit,no);	
   }

   return(0);
}
void handle_send_asf_hd( connecttab* c, struct timeval* tvP )
    {
    int sz, coast,no;
    ClientData client_data;
    time_t elapsed;
    httpd_conn* hc = c->hc;
    struct iovec iv[HD_BUF_NO+1];
    
    /* Do we need to write the headers first? */
#ifdef TESTING
    sprintf(logmsg,"==> New connection fd=%d,send_asf_hd",hc->conn_fd);
    LogMsg(logmsg);
#endif
    fill_asf_header(hc);

    if ( hc->responselen == 0 )
	{
	/* No, just write the file. */
	//sz = write(
	//    hc->conn_fd, &(hc->file_address[c->bytes_sent]),
	//    MIN( c->bytes_to_send - c->bytes_sent, c->limit ) );
	set_asf_hd_package(iv,0,&no,&hc->asf,hc->hd_buf);
#ifdef TESTING
	sz = my_writev( hc->conn_fd, iv, no ,"HD-1");
#else
	sz = writev( hc->conn_fd, iv, no );
#endif
	//syslog( LOG_ERR, "write without header, ASF_ALL_HEADER_LEN=%d",ASF_ALL_HEADER_LEN );
	

	}
    else
	{

	iv[0].iov_base = hc->response;
	iv[0].iov_len = hc->responselen;
	set_asf_hd_package(iv,1,&no,&hc->asf,hc->hd_buf);
#ifdef TESTING
	sz = my_writev( hc->conn_fd, iv, no+1 ,"HD-2");
#else
	sz = writev( hc->conn_fd, iv, no+1 );
#endif
	//syslog( LOG_ERR, "write with header, ASF_ALL_HEADER_LEN=%d",ASF_ALL_HEADER_LEN );
	
	}

    if ( sz == 0 ||
	 ( sz < 0 && ( errno == EWOULDBLOCK || errno == EAGAIN ) ) )
	{
	/* This shouldn't happen, but some kernels, e.g.
	** SunOS 4.1.x, are broken and select() says that
	** O_NDELAY sockets are always writable even when
	** they're actually not.
	**
	** Current workaround is to block sending on this
	** socket for a brief adaptively-tuned period.
	** Fortunately we already have all the necessary
	** blocking code, for use with throttling.
	*/
//delay:
#if 0
	c->wouldblock_delay += MIN_WOULDBLOCK_DELAY;
	c->conn_state = CNST_PAUSING;
	fdwatch_recompute = 1;
	client_data.p = c;
	c->wakeup_timer = tmr_create(
	    tvP, wakeup_connection, client_data, c->wouldblock_delay, 0 );
#endif	    
	   
	return;
	}
    if ( sz < 0 )
	{
	/* Something went wrong, close this connection.
	**
	** If it's just an EPIPE, don't bother logging, that
	** just means the client hung up on us.
	**
	** On some systems, write() occasionally gives an EINVAL.
	** Dunno why, something to do with the socket going
	** bad.  Anyway, we don't log those either.
	*/
	if(StopAsf) return;	//got usr1 signal
	if ( errno != EPIPE && errno != EINVAL )
	    syslog( LOG_ERR, "write - %m" );
#ifdef TESTING
	sprintf(logmsg,"Send ASF Header Error!!!, %s",strerror(errno));
  	LogMsg(logmsg);
	sprintf(logmsg,"Close account id=%d",hc->conn_fd);
	LogMsg(logmsg);
#endif
	hc->should_linger=0;
	clear_connection( c, tvP );
	
	return;
	}

    /* Ok, we wrote something. */
    tmr_reset( tvP, c->idle_send_timer );
    /* Was this a headers + file writev()? */
    if ( hc->responselen > 0 )
	{
	/* Yes; did we write only part of the headers? */
	if ( sz < hc->responselen )
	    {
	    /* Yes; move the unwritten part to the front of the buffer. */
	    int newlen = hc->responselen - sz;
	    (void) memcpy( hc->response, &(hc->response[sz]), newlen );
	    hc->responselen = newlen;
	    sz = 0;
	    }
	else
	    {
	    /* Nope, we wrote the full headers, so adjust accordingly. */
	    sz -= hc->responselen;
	    hc->responselen = 0;
	    }
	}
    /* And update how much of the file we wrote. */
    hc->asf.bytes_sent += sz;

    /* Are we done? */
#ifdef TESTING
	sprintf(logmsg,"asf.bytes_sent=%d asf.bytes=%d\n",hc->asf.bytes_sent,hc->asf.bytes);
	LogMsg(logmsg);
#endif
    if ( hc->asf.bytes_sent >= hc->asf.bytes )
	{
	/* ASF header are all sent! */
 	c->conn_state=ASF_SEND_IMG;
	}

    /* Tune the (blockheaded) wouldblock delay. */
    if ( c->wouldblock_delay > MIN_WOULDBLOCK_DELAY )
	c->wouldblock_delay -= MIN_WOULDBLOCK_DELAY;

    /* If we're throttling, check if we're sending too fast. */
    if ( c->limit != THROTTLE_NOLIMIT )
	{
	elapsed = tvP->tv_sec - c->started_at;
	if ( elapsed == 0 || hc->asf.bytes_sent / elapsed > c->limit )
	    {
	    c->conn_state = CNST_PAUSING;
	    fdwatch_recompute = 1;
	    /* When should we send the next c->limit bytes
	    ** to get back on schedule?  If less than a second
	    ** (integer math rounding), use 1/8 second.
	    */
	    coast = ( hc->asf.bytes_sent + c->limit ) / c->limit - elapsed;
	    client_data.p = c;
	    c->wakeup_timer = tmr_create(
		tvP, wakeup_connection, client_data,
		coast ? ( coast * 1000L ) : 125L, 0 );
	    }
	}
    }
#ifdef NewASF
void send_error_data_to_conn(httpd_conn *hc)
{
   int sz;
   
   if(hc->is_mp9){
   sz=write(hc->conn_fd,&EndStreaming,12);
#ifdef TESTING
   sprintf(logmsg,"===> Send EndStreaming packet,sz=%d\n",sz);
   LogMsg(logmsg);
#endif
   //hc->should_linger=0;
   }
}
#endif
void handle_send_asf_img( connecttab* c, struct timeval* tvP )
    {
    int sz, coast,no,ccode;
    ClientData client_data;
    time_t elapsed;
    httpd_conn* hc = c->hc;
    struct iovec iv[32];
    int retry=1; 
    long	data_bytes;

s0:
    ccode=set_buf_package(iv,hc,c->limit,&no);
    if(ccode==-1) { //open account failed
#ifdef TESTING
	LogMsg("IMG Open accoutn failed");
#endif
	hc->should_linger=0;
	clear_connection( c, tvP );
	return;
    }
    if (ccode==2 && hc->more_data_pkt){ //send next data packet

	ccode=set_buf_package(iv,hc,c->limit,&no);
    }
    if (ccode){
	if(StopAsf) return;	//got usr1 signal
	if(hc->drv_busy>MAX_DRV_BUSY_NO){
	        hc->more_data_pkt=0;
        	free_data_packet(hc);
  		//sz=write(hc->conn_fd,ErrData,sizeof(ErrData));
#ifdef TESTING
		//sprintf(logmsg,"===> Send Empty data packet,sz=%d",sz);
		//LogMsg(logmsg);
		sprintf(logmsg,"Can't get buffer from driver drv_busy=%d, Close account id=%d",hc->drv_busy,hc->conn_fd);
		LogMsg(logmsg);
#endif
		hc->should_linger=0;
		clear_connection( c, tvP );
	}
	return;
    }
#ifdef TESTING
    sz = my_writev( hc->conn_fd, iv, no ,"IMG");
#else
    sz = writev( hc->conn_fd, iv, no );
#endif

    //syslog( LOG_ERR, "write image, send %d bytes successful",sz );



    if ( sz == 0 ||
	 ( sz < 0 && ( errno == EWOULDBLOCK || errno == EAGAIN ) ) )
	{
	/* This shouldn't happen, but some kernels, e.g.
	** SunOS 4.1.x, are broken and select() says that
	** O_NDELAY sockets are always writable even when
	** they're actually not.
	**
	** Current workaround is to block sending on this
	** socket for a brief adaptively-tuned period.
	** Fortunately we already have all the necessary
	** blocking code, for use with throttling.
	*/
//delay:
	if(hc->lan_busy>MAX_LAN_BUSY_NO){
	        hc->more_data_pkt=0;
        	free_data_packet(hc);
#ifdef TESTING
		sprintf(logmsg,"sz=%d no=%d\n",sz,no);
		LogMsg(logmsg);
		sprintf(logmsg,"Lan busy, lan_busy=%d, Close account id=%d",hc->lan_busy,hc->conn_fd);
		LogMsg(logmsg);
#endif
		hc->should_linger=0;
		clear_connection( c, tvP );
        }
	else
		hc->lan_busy++;
#ifdef SKIP_FRAME
	if(sz==0)
	    	chk_skip_frame(hc);
#endif
#if 0
	c->wouldblock_delay += MIN_WOULDBLOCK_DELAY;
	c->conn_state = CNST_PAUSING;
	fdwatch_recompute = 1;
	client_data.p = c;
	c->wakeup_timer = tmr_create(
	    tvP, wakeup_connection, client_data, c->wouldblock_delay, 0 );
#endif	    
	   
	return;
	}
    if ( sz < 0 )
	{
	/* Something went wrong, close this connection.
	**
	** If it's just an EPIPE, don't bother logging, that
	** just means the client hung up on us.
	**
	** On some systems, write() occasionally gives an EINVAL.
	** Dunno why, something to do with the socket going
	** bad.  Anyway, we don't log those either.
	*/
#ifdef TESTING
    	sprintf(logmsg,"Last frame_no=%02d,total_frame=%d ",hc->frame_no,hc->total_frame); 
    	LogMsg(logmsg);
        sprintf(logmsg,"total_t=%u base_t=%lu ",hc->prev_time,hc->base_time);
        LogMsg(logmsg);
#endif
	if ( errno != EPIPE && errno != EINVAL )
	    syslog( LOG_ERR, "write - %m" );
        hc->more_data_pkt=0;
        free_data_packet(hc);
#ifdef TESTING
	sprintf(logmsg,"Send ASF Image Error!!!,errno=%d %s",errno,strerror(errno));
	LogMsg(logmsg);
	sprintf(logmsg,"Close account id=%d",hc->conn_fd);
	LogMsg(logmsg);
#endif
	hc->should_linger=0;
	clear_connection( c, tvP );
	
	return;
	}

    /* Ok, we wrote something. */
    hc->lan_busy=0;
    tmr_reset( tvP, c->idle_send_timer );
    /* And update how much of the file we wrote. */
    hc->img_bytes_sent += sz;

    /* Are we done? */
#ifdef NewASF
      if(hc->is_mp9)
	data_bytes=hc->data_pkt_size+12;
      else
	data_bytes=hc->data_pkt_size;
#else
	data_bytes=hc->data_pkt_size;
#endif
      if(hc->img_bytes_sent>=data_bytes){
	/* This data packet is finished! */
        free_data_packet(hc);
#ifdef TESTING
#if 1
        if (hc->more_data_pkt || !hc->limit_frame)
	   return; //need to send rest data
	if (!StopImage) //limit_frame 
	   return;
#else
        if (hc->more_data_pkt )
	   return; //need to send rest data
#endif
//close_c:
    	sprintf(logmsg,"Last frame_no=%02d,total_frame=%d ",hc->frame_no,hc->total_frame); 
	LogMsg(logmsg);
	sprintf(logmsg,"Close account id=%d",hc->conn_fd);
	LogMsg(logmsg);
	syslog( LOG_ERR, "Close from close_c" );
	hc->should_linger=0;
	clear_connection( c, tvP );
	StopImage=0;
#endif
	return;
	}

    if(hc->img_bytes_sent==hc->data_hd_len && retry){
	retry=0;
	goto s0; //send data immediately
    }
    /* Tune the (blockheaded) wouldblock delay. */
    if ( c->wouldblock_delay > MIN_WOULDBLOCK_DELAY )
	c->wouldblock_delay -= MIN_WOULDBLOCK_DELAY;

    /* If we're throttling, check if we're sending too fast. */
    if ( c->limit != THROTTLE_NOLIMIT )
	{
	elapsed = tvP->tv_sec - c->started_at;
	if ( elapsed == 0 || hc->img_bytes_sent / elapsed > c->limit )
	    {
	    c->conn_state = CNST_PAUSING;
	    fdwatch_recompute = 1;
	    /* When should we send the next c->limit bytes
	    ** to get back on schedule?  If less than a second
	    ** (integer math rounding), use 1/8 second.
	    */
	    coast = ( hc->img_bytes_sent + c->limit ) / c->limit - elapsed;
	    client_data.p = c;
	    c->wakeup_timer = tmr_create(
		tvP, wakeup_connection, client_data,
		coast ? ( coast * 1000L ) : 125L, 0 );
	    }
	}
    }

#ifdef TESTING
static Img_S0 *img_s0 = (Img_S0 *) IMG_S0;
static Img_S1 *img_s1 = (Img_S1 *) IMG_S1;
void dump_imgs1(void)
{
   int i;

   sprintf(logmsg,"DUMP buf: img_s0->w=%d",img_s0->w);
   LogMsg(logmsg);
   for(i=0;i<img_s0->m;i++){
	sprintf(logmsg,"img_s1[%d].cnt=%d sz=%ld   ",i,img_s1[i].cnt,img_s1[i].sz);
	LogMsg(logmsg);
   }
}
#endif
void close_asf_buf(httpd_conn *hc)
{
#ifndef DEF_MPEG
   int i;
#endif
// Sand modified 
//   if(!hc->is_asf &&!hc->is_jpg) return;
   if(!hc->is_asf) return;
#ifdef TESTING
    syslog(LOG_ERR,"Total frame_no=%d",hc->total_frame);
    sprintf(logmsg,"Total frame_no=%d",hc->total_frame);
    LogMsg(logmsg);
#endif
asf_log_time(hc,0);
#ifndef DEF_MPEG
   for(i=0;i<MAX_IMG_BUF;i++){
	if(hc->img[i].hd){
   	    //if(StopAsf!=2) 
	        IMG_ReleaseImg(hc->img[i].index, hc->account);  
#ifdef TESTING
	   sprintf(logmsg,"Release buffer index=%d account=%d addr=%lx\n",hc->img[i].index,hc->account,(unsigned long)hc->img[i].hd);	
	   LogMsg(logmsg);
#endif
	    hc->img[i].hd=0;
	    hc->img[i].index=-1;
	}
   }
#ifdef TESTING
	sprintf(logmsg,"Close_asf_account=%d\n",hc->account);
	LogMsg(logmsg);
#endif
   if(hc->account!=-1)
     IMG_close_acnt(hc->conn_fd);
   hc->account=-1;
#ifdef TESTING
   dump_imgs1();
#endif
#endif
}
void asf_log_time(httpd_conn *hc,int start)
{
   if(hc->reject)
	return;

   if (start)
      AddLog("thttpd",SYSLOG_NORMAL,1,httpd_ntoa(&hc->client_addr),hc->remoteuser);
   else 
      AddLog("thttpd",SYSLOG_NORMAL,2,httpd_ntoa(&hc->client_addr),hc->remoteuser);

#ifdef TESTING
  {
   time_t t;

   time(&t);
   if (start)
      sprintf( logmsg, "ASF Start: %.20s - %s",
	    httpd_ntoa( &hc->client_addr ),  ctime(&t));
   else 
      sprintf( logmsg, "ASF Close: %.20s - %s",
	    httpd_ntoa( &hc->client_addr ),  ctime(&t) );
   LogMsg(logmsg);
   }
#endif
}

//Sand adds this function for sending Motion JPEG data
void handle_send_jpg( connecttab* c, struct timeval* tvP ){
	httpd_conn* hc = c->hc;
	int retry=1;
	char hdr[12];
        int count=0;
	img_info *img;
	IMG_INFO *info;
 	char pushhdr[64]="Content-type: multipart/x-mixed-replace; boundary=--ServerPush\n\n";
 	char pushtag1[13]="--ServerPush\n";
 	char pushtag2[26]="Content-type: image/jpeg\n\n";

	if(StopAsf) return;     //got usr1 signal
	
	/* if the data sending is not finished, continue */
	if(hc->more_data_pkt==1)
	{
	
        img=&hc->img[0];
	// Send data , retry 3 times
         for(retry=3;(img->bytes - hc->img_bytes_sent) > 0 && retry >0 ; retry--){
       	count = write( hc->conn_fd, img->hd+20+hc->img_bytes_sent,img->bytes-hc->img_bytes_sent);
#ifdef TESTING
	sprintf(logmsg,"Continue sending , should send %ld , sent %d bytes",img->bytes- hc->img_bytes_sent,count);
	LogMsg(logmsg);
#endif
	if(count > 0)
		{
		hc->img_bytes_sent += count;
		/* Reset idle timer so that it will not timeout */
		tmr_reset( tvP, c->idle_send_timer );
		usleep(50);
		}
      	}
		/* sending data is not finished */	   
		if((img->bytes -hc->img_bytes_sent) > 0){
			hc->more_data_pkt=1;
		}
		else /* finished, we can release image now */
		{
			// reset these records
		  hc->more_data_pkt=0;
                  hc->img_bytes_sent = 0;
	               //Release Image
#ifdef TESTING
		  sprintf(logmsg,"account %d final release index %d",hc->account, img->index);
		  LogMsg(logmsg);  
#endif
 		  if(hc->total_img==0)
 			hc->total_img=1;
	          IMG_ReleaseImg(img->index, hc->account);
		}
	}
	else
	{

         /* open account */
	if(hc->account==-1){
		hc->account = IMG_open_acnt(hc->conn_fd);
		// open account failed
		if(hc->account == -1 )
		{
			hc->should_linger=0;
			clear_connection( c, tvP );
                        return;
                }
        }

        img=&hc->img[0];

        img->hd = IMG_GetImg(&img->bytes, &img->index, hc->account);

	if( img->hd == NULL)
		return;
        else{
		info=(IMG_INFO *)img->hd;
	     if(hc->is_jpg==1) // mjpeg.cgi
		{

       // Send Header, Assume that there won't be any problem with this write
                memset(hdr,'\0',12);
                sprintf(hdr,"%06ld%3d%3d",img->bytes,info->video.ResW, info->video.ResH);
//		LogMsg(hdr);
                count=write( hc->conn_fd,hdr,12);
		}
	    else if(hc->is_jpg==2)
		{
			if ( hc->total_img==0 )
			{
			count=write( hc->conn_fd,"HTTP/1.0 200 OK\r\n",17);
	 		count=write( hc->conn_fd,pushhdr,sizeof(pushhdr));
			}
		 	count=write( hc->conn_fd,pushtag1,sizeof(pushtag1));
		 	count=write( hc->conn_fd,pushtag2,sizeof(pushtag2));
		}
	// Send data , retry 3 times
         for(retry=3;(img->bytes - hc->img_bytes_sent) > 0 && retry >0 ; retry--){
       	count = write( hc->conn_fd, img->hd+20+hc->img_bytes_sent,img->bytes-hc->img_bytes_sent);
#ifdef TESTING
	sprintf(logmsg,"Send %d bytes, index %d account %d ",count,img->index,hc->account);
	LogMsg(logmsg);
#endif 
	if(count > 0){
		hc->img_bytes_sent += count;
		/* Reset idle timer so that it will not timeout */
		tmr_reset( tvP, c->idle_send_timer );
		usleep(50);
		}
#ifdef TESTING
	else{
		sprintf(logmsg,"Write Error! %d: %s",errno,strerror(errno));
		LogMsg(logmsg);
	 	}
#endif
      	}
		/* sending data is not finished */	   
		if((img->bytes - hc->img_bytes_sent) > 0){
		hc->more_data_pkt=1;
		}
		else /* finished, we can release image now */
		{
			// reset these records
		  hc->more_data_pkt=0;
                  hc->img_bytes_sent = 0;
	               //Release Image
#ifdef TESTING
		  sprintf(logmsg,"account %d release index %d",hc->account,img->index);
		  LogMsg(logmsg);  
#endif
 		  if(hc->total_img==0)
 			hc->total_img=1;
	          IMG_ReleaseImg(img->index, hc->account);
		}
       }
    }
	
#if 0
	// Deal with pipe broken error condition
	if ( errno == EPIPE )
	{
#ifdef TESTING
		sprintf(logmsg,"Send ASF Image Error!! still have %d bytes to send, %s",img->bytes-hc->img_bytes_sent,strerror(errno));
		LogMsg(logmsg);
		sprintf(logmsg,"Close account id=%d",hc->conn_fd);
		LogMsg(logmsg);
#endif
		hc->should_linger=0;
		clear_connection( c, tvP );
		asf_log_time(hc,0);
		return;
       }
#endif

}

