/*
 *  linux/arch/armnommu/mach-dm270/mm.c
 *
 *    Copyright (C) 2003 Cadenux.com <http://www.cadenux.com>
 *    Gregory Nutt <greg.nutt@cadenux.com>
 *
 *  Derived from linux/arch/armnommu/mach-dsc25/mm.c:
 *
 *    Copyright (C) 1998-1999 Russell King
 *    Copyright (C) 1999 Hugo Fiennes
 *
 *  Extra MM routines for the SA1100 architecture
 *
 *  1999/12/04 Nicolas Pitre <nico@cam.org>
 *	Converted memory definition for struct meminfo initialisations.
 *	Memory is listed physically now.
 *
 *  2000/04/07 Nicolas Pitre <nico@cam.org>
 *	Reworked for run-time selection of memory definitions
 *
 *  2001/02/19 Gordon McNutt <gmcnutt@ridgerun.com>
 *      Modified mm-sa1100.c to make this, mm-dsc21.c.
 *
 *  2002/10/18 Gregory Nutt <greg.nutt@cadenux.com>
 *      Modified for the dsc25
 *
 *  2003/02/19 Gregory Nutt <greg.nutt@cadenux.com>
 *      Modified for the dm270
 */

#include <linux/config.h>
#include <linux/mm.h>
#include <linux/init.h>
#include <linux/bootmem.h>

#include <asm/hardware.h>
#include <asm/pgtable.h>
#include <asm/page.h>
#include <asm/mach-types.h>

#include <asm/mach/map.h>
 
#ifdef CONFIG_DISCONTIGMEM

/* Our node_data structure for discontigous memory.
 * There is 4 possible nodes i.e. the 4 dm270 RAM banks.
 */

static bootmem_data_t node_bootmem_data[4];

pg_data_t dm270_node_data[4] =
{ { bdata: &node_bootmem_data[0] },
  { bdata: &node_bootmem_data[1] },
  { bdata: &node_bootmem_data[2] },
  { bdata: &node_bootmem_data[3] } };

#endif
