#ifndef net_cadenux_h
#define net_cadenux_h

typedef struct rrsock_s {
    struct socket *owner;                         /* Back to the OS */
    struct sockservice *bound;                           /* binding */

    /* Proc waiting for incoming connect */

    wait_queue_head_t accepting;                 /* waiting for connection */

    /* Proc waiting to receive data */

    wait_queue_head_t reader_sel;                /* waiting for read data via select */
    wait_queue_head_t reader;                    /* waiting for read data */
    char *readptr;                                /* reading to */
    int readlen;                                  /* how much to read */

    /* Proc waiting to *give us* data */

    wait_queue_head_t sender;                    /* waiting for send data */
    char *sendptr;                                /* sending from */
    int sendlen;                                  /* how much to send */

    /* only if sock state=connected */

    int serving;                                  /* layercomm server ? */
    struct lcomm_conn *lcomm_connsrv;                    /* if serving */
    void * lcomm_conncli;                   /* if a layercomm client */

    /* Don't use ring buffer for now. nonblockin readers must have */
    /* a blocking writer waiting. nonblocking writers must have a */
    /* blocking reader. For nonblocking writer->reader, use ring buffer */

#define RCVBUFLEN 2048                             /* Hold incoming data */

    // This does NOT wrap. See handling below

    char rcvbuf [ RCVBUFLEN ];
    int rcvput;
    int rcvget;
} rrsock;

#endif
