//
// File: head_dm270.S
//
// (Derived from head-arm-atmel.S and Boot.asm)
//
// Contains the necessary h/w setup specific to the TI DM270 EVM board.
//
// Copyright (C) 2002 RidgeRun, Inc.
// Author: RidgeRun, Inc  <skranz@ridgerun.com>
//  - Derived from head_dsc21.S, 9/6/02, Gregory Nutt
//  - Derived from head_dsc25.S, 2/19/03, Gregory Nutt
//
//  This program is free software; you can redistribute  it and/or modify it
//  under  the terms of  the GNU General  Public License as published by the
//  Free Software Foundation;  either version 2 of the  License, or (at your
//  option) any later version.
//
//  THIS  SOFTWARE  IS  PROVIDED  ``AS  IS''  AND   ANY  EXPRESS  OR IMPLIED
//  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
//  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT,  INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
//  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
//  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
//  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//  You should have received a copy of the  GNU General Public License along
//  with this program; if not, write  to the Free Software Foundation, Inc.,
//  675 Mass Ave, Cambridge, MA 02139, USA.
//
// Please report all bugs/problems to the author or <support@dsplinux.net>
//
// key: RRGPLCR (do not remove)
//
        .text
        .align
        .global _start

#define I_BIT        0x80
#define F_BIT        0x40
#define ARM_MODE_SVC 0x13

        // Turn off IRQ/FIQ and put into service mode.
_start: mov r0, #(ARM_MODE_SVC | I_BIT | F_BIT)
        msr cpsr, r0

	// Initialize the hardware
	bl hw_ini	

        // Setup Relocation register.
        ldr r10, =0x00000000
        
        // Setup Stack
        ldr sp, =0x08000 @ use IRAM for stack, from 7800-8000
        
        mov fp, #0
        b   bootstrap
