#ifndef PROTOTYPE_H
#define PROTOTYPE_H

#include "types.h"

#define PUSH_BUTTON       2   /* push button */
#define GPIO_REBOOT       9
#define LED_GPIO_WLAN    (30-16)
#define LED_GPIO_PWR     (28-16)
#define LED_GPIO_ACT     (29-16)
#define GPIO_DR0         0x00030580
#define GPIO_SR0         0x0003058C
#define GPIO_SR1         0x0003058E
#define GPIO_CR0         0x00030592
#define GPIO_CR1         0x00030594
#define GpIOBitGet0(x)    (*(volatile u32 *)GPIO_SR0) & (0x01 << x)
#define GpIOBitSet0(x)    *(volatile u16 *)GPIO_SR0 = (0x01 << x)
#define GpIOBitSet1(x)    *(volatile u16 *)GPIO_SR1 = (0x01 << x)
#define GpIOBitClear0(x)  *(volatile u16 *)GPIO_CR0 = (0x01 << x)
#define GpIOBitClear1(x)  *(volatile u16 *)GPIO_CR1 = (0x01 << x)
#define DR0Set(x)         *(volatile u32 *)GPIO_DR0 |= (0x01 << x)

typedef unsigned BOOL;

/* dm9000 */

void to_download(int dnl);
#define Lan_Receive(x,y)   dmfe_receive(x,y)
#define Lan_Transmit(x,y)  dmfe_transmit((u16*)x,y)
BOOL dmfe_GetMACAddr(u8 *mac);
BOOL dmfe_SetMACAddr(u8 *mac);
void dmfe_receive(u16 *data, u16 *len);
void dmfe_transmit(u16 *data, u16 len);
int dmfe_init(void);
BOOL dmfe_validateMacAddress(u8 *addr);

#endif
