/*
 * File: sdram.h
 *
 * This is an sdram initialization interface. The implemention of this
 * interface will interact with the particular SDRAM controller h/w chipset.
 *
 * Copyright (C) 2002 RidgeRun, Inc.
 * Author: RidgeRun, Inc  <skranz@ridgerun.com>
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS  PROVIDED  ``AS  IS''  AND   ANY  EXPRESS  OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT,  INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Please report all bugs/problems to the author or <support@dsplinux.net>
 *
 * key: RRGPLCR (do not remove)
 *
 */

#ifndef SDRAM_H
#define SDRAM_H

// -- Special Case --
//  The system must provide a *.S file which implements a
//  routine called "sdram_ini". This function must be implemented
//  in assembly code and must not rely on the stack pointer. This
//  routine is called prior to the system stack being setup which
//  is why it cannot be implemented in "C". It is called very early
//  in the boot from flash process. Specifically it is called from
//  the head*.o object. Note: If the rrload image is downloaded to
//  SDRAM using a jtag debugger, and run, then the head*.o logic
//  is not run and execution starts at main() within the
//  rrload_base.o object.
//
//  Here is an example assembly implementation for reference:
//  
//  +-------------------
//  |  .text
//  |  .align
//  |  .global sdram_ini
//  |  sdram_ini:
//  |    // Put your sdram initialization logic here,
//  |    // and finish up by returning to the caller
//  |    // like this...
//  |    mov pc, lr
//  +-------------------

#endif
