/***********************************************************************
 * File: xflat/xflat_accessors.h
 *
 * Created 2002, Copyright (C) 2002 Cadenux, LLC.
 * Author: Gregory Nutt <greg.nutt@cadenux.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Please report all bugs/problems to the author or <info@cadenux.com>
 ***********************************************************************/

#ifndef _XFLAT_ACCESSORS_H_
#define _XFLAT_ACCESSORS_H_

/***********************************************************************
 * Included Files
 ***********************************************************************/

#include <stdio.h> /* FILE */

/***********************************************************************
 * Compilation Switches
 ***********************************************************************/

#define XFLAT_UCLIBC_0915 1

/***********************************************************************
 * Definitions
 ***********************************************************************/

enum xflat_varid
{
  XFLAT_STDIN,
  XFLAT_STDOUT,
  XFLAT_STDERR,
  XFLAT_SYS_ERRLIST,
  XFLAT_ERRNO,
  XFLAT_H_ERRNO,
  XFLAT_ENVIRON,
  XFLAT_OPTARG,
  XFLAT_OPTIND,
#ifdef XFLAT_UCLIBC_0915
  XFLAT_STDIO_OPENLIST
#endif /* XFLAT_UCLIBC_0915 */
};

/***********************************************************************
 * Global Function Prototypes
 ***********************************************************************/

extern void *
xflat_varptr(enum xflat_varid varid);

#endif /* _XFLAT_ACCESSORS_H_ */
