/* linux/include/asm-arm/arch-c5471/time.h */

#ifndef __ASM_ARCH_TIME_H__
#define __ASM_ARCH_TIME_H__

/* The actually timer initialization is performed in the file
 * arch/armnommu/mach-c5471/time.c.  This inline function is
 * just a thin candy coating to get to that function.
 */

extern void c5471_setup_timer(struct irqaction *timer_irq);

/* setup_timer() is "called" from arch/armnommu/kernel/time.c
 * In the context where setup_timer runs (in this context, timer_irq
 * is declared as a static intialized variable.  Provided that
 * the asm/arch/time.h is included AFTER this declaration, the
 * following should be quite happy:
 */

void __inline__ setup_timer(void)
{
  c5471_setup_timer(&timer_irq);
}

#endif /* __ASM_ARCH_TIME_H__ */
