/* asm/arch/memconfig.h */

#ifndef __ASM_ARCH_MEMCONFIG_H_
#define __ASM_ARCH_MEMCONFIG_H_

/* Specify Platform */

#define CADENUX_DM270_TI 1

/* FLASH Resources */

#define TOSHIBA_TC58FB160FT 0
#define FUJITSU_MBM29DL323B 1
#define INTEL_28F128 2
#define INTEL_28F160 3
#define INTEL_28F320 4
#define INTEL_28F320x2 5
#define AMD_AM29DL164DT 6
#define AMD_AM29L640Dx2 7
#define FUJITSU_29LV320T 8
#define CADENUX_FLASH_TYPE FUJITSU_29LV320T

#define CADENUX_FLASH_BASE 0x00100000
#define CADENUX_FLASH_SIZE 0x00400000
#define FLASH_MEM_BASE CADENUX_FLASH_BASE
#define FLASH_SIZE CADENUX_FLASH_SIZE

/* Compression settings */


#define CADENUX_KERNEL_COMPRESSED 0
#define CADENUX_FS_COMPRESSED 0

/* FLASH Memory Map */

#define CADENUX_FLASH_OFFSET 0x00000000

#define CADENUX_BTLDR_FLASH_START 0x00100000
#define CADENUX_BTLDR_FLASH_OFFSET 0x00000000
#define CADENUX_BTLDR_FLASH_SIZE 0x00010000

#define CADENUX_PARAMS_FLASH_START 0x00110000
#define CADENUX_PARAMS_FLASH_OFFSET 0x00010000
#define CADENUX_PARAMS_FLASH_SIZE 0x00010000

#define CADENUX_KERNEL_FLASH_START 0x00120000
#define CADENUX_KERNEL_FLASH_OFFSET 0x00020000
#define CADENUX_KERNEL_FLASH_SIZE 0x00100000

#define CADENUX_FS_FLASH_START 0x00220000
#define CADENUX_FS_FLASH_OFFSET 0x00120000
#define CADENUX_FS_FLASH_SIZE 0x002e0000

/* SDRAM Resources */

#define SDRAM_TYPE_UNKNOWN 0
#define SDRAM_TYPE_D4564163 1
#define SDRAM_TYPE_K4S561632D 2
#define SDRAM_TYPE_TC55V16256 3
#define SDRAM_TYPE_K4S281633D 4
#define SDRAM_TYPE_HY57V653220 5
#define CADENUX_SDRAM_TYPE SDRAM_TYPE_K4S561632D

#define CADENUX_SDRAM_BASE 0x02100000
#define CADENUX_SDRAM_SIZE 0x04000000

/* SDRAM Memory Map */

#define CADENUX_BTLDR_SDRAM_START 0x02100000
#define CADENUX_BTLDR_SDRAM_END 0x02120000
#define CADENUX_FS_SDRAM_START 0x02120000
#define CADENUX_KERNEL_SDRAM_START 0x02920000

/* IRAM Memory Map */

#undef CADENUX_USE_IRAM
#define CADENUX_IRAM_BASE 0x00000004

/* Bootloader Settings */

#undef CADENUX_BTLDR_NO_MENUS
#define CADENUX_BTLDR_MEMORY_DEBUG 1
#define CADENUX_BTLDR_MEMMAP_DEBUG 1
#undef CADENUX_BTLDR_CS8900_DEBUG
#undef CADENUX_BTLDR_FLASH_DEBUG

/* Linux Kernel */

#undef CADENUX_BOOT_FROM_FLASH
#define CADENUX_BOOT_FROM_SDRAM 1
#define CADENUX_KERNEL_IMAGE_START 0x02920000
#define CADENUX_KERNEL_STACK 0x00007800

/* Linux Root File System */

#define CADENUX_FLASH_FS 0
#define CADENUX_FILESYS_START 0x02120020
#define CADENUX_FILESYS_SIZE  0x007fffe0

/* Linux Memory Pool */

#define CADENUX_DRAM_BASE 0x02920000
#define CADENUX_DRAM_SIZE 0x037e0000

/* Device Description */

#define CADENUX_ETHERNET_BASE 0x06b00000

#define ETHERNET_TYPE_NONE 0
#define ETHERNET_TYPE_UNKNOWN 1
#define ETHERNET_TYPE_CS8900 2
#define CADENUX_ETHERNET_TYPE ETHERNET_TYPE_CS8900

#define ETHERNET_PHY_UNKNOWN 0
#define ETHERNET_PHY_LU3X31T_T64 1
#define ETHERNET_PHY_AC101L 2
#define CADENUX_ETHERNET_PHY ETHERNET_PHY_UNKNOWN

/* Networking */

#define CADENUX_NETWORK_TARGET_IP "10.0.0.21"
#define CADENUX_NETWORK_TARGET_MAC "00:e0:81:10:36:de"
#define CADENUX_NETWORK_TARGET_MASK "255.255.255.0"
#define CADENUX_NETWORK_TARGET_BCAST "10.0.0.255"
#define CADENUX_NETWORK_TARGET_GW_IP "10.0.0.1"
#define CADENUX_NETWORK_TARGET_NET_IP "10.0.0.0"
#define CADENUX_NETWORK_SOURCE_IP "10.0.0.3"
#define CADENUX_NETWORK_SOURCE_MAC "00:03:47:7B:28:40"

#endif /* __ASM_ARCH_MEMCONFIG_H_ */
