/************************************************************************
 * asm-armnommu/arch-dsc25/gio_ioctl.h
 ************************************************************************/

#ifndef __ASM_ARCH_GIO_IOCTL_H__
#define __ASM_ARCH_GIO_IOCTL_H__
 
/************************************************************************
 * Included Files
 ************************************************************************/

#include <asm/ioctl.h>
 
/************************************************************************
 * Definitions
 ************************************************************************/

#define GIO_MAGIC_NUMBER 'g'

/* Major numbers, (from Documentation/devices.txt local/experimental list)  */
 
#define GIO_MAJOR 125
 
/************************************************************************
 * GIO_DIRECTION: The GIO_DIRECTION can be either input (GIO_INPUT) or
 * output (GIO_OUTPUT).  If unspecified, the GIO will default to input.
 */

#define GIO_DIRECTION _IO(GIO_MAGIC_NUMBER, 0)

/* GIO_DIRECTION Arguments: */

#define GIO_OUTPUT 0
#define GIO_INPUT  1

/************************************************************************
 * GIO_INVERSION: The GIO polarity of the GIO pin can be inverted.  If
 * unspecified, the default behavior will be NOT inverted.
 */

#define GIO_INVERSION _IO(GIO_MAGIC_NUMBER, 1)

/* GIO_INVERSION Arguments: */

#define GIO_UNINVERTED 0
#define GIO_INVERTED   1

/************************************************************************
 * GIO_BITSET: If the direction is set to output, this ioctl will set the
 * output.  If the direction is input, this ioctl will return the value
 * of the GIO pin (0, 1, or -1 on error).
 */

#define GIO_BITSET _IO(GIO_MAGIC_NUMBER, 2)

/* GIO_BITSET arguments:  None */

/************************************************************************
 * GIO_BITCLR: If the direction is set to output, this ioctl will clear the
 * output.  If the direction is input, this ioctl will return the value
 * of the GIO pin (0, 1, or -1 on error).
 */

#define GIO_BITCLR _IO(GIO_MAGIC_NUMBER, 3)

/* GIO_BITCLR arguments:  None */

/************************************************************************
 * GIO_IRQPORT: For the DSC21, GIO0-GIO7 can be configured as external
 * interrupt ports
 */

#define GIO_IRQPORT _IO(GIO_MAGIC_NUMBER, 4)

/* GIO_IRQPORT arguments:*/

#define GIO_NOINTERRUPT 0
#define GIO_INTERRUPT   1

/************************************************************************
 * GIO_FSEL: For the DSC21 GI11-GIO13 can be used as dedicated function
 * ports rather than general purpose IO ports.
 */

#define GIO_FSEL _IO(GIO_MAGIC_NUMBER, 5)

/* GIO_FSEL Arguments: */

#define GIO_NORMAL     0 /* 0=GIO11-GIO13 Normal */

#define GIO_IOC_MAXNR 5
 
#endif /* __ASM_ARCH_GIO_IOCTL_H__ */
