/*
 * linux/include/asm/arch/irqs.h:
 * IRQ numbers for the dsc21.
 *
 * Copyright: (C) 2001 RidgeRun, Inc. (http://www.ridgerun.com)
 * Author: Gordon McNutt <gmcnutt@ridgerun.com>
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 *
 * THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 * WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 * NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 * USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * You should have received a copy of the  GNU General Public License along
 * with this program; if not, write  to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __ASM_ARCH_IRQS_H__
#define __ASM_ARCH_IRQS_H__

/* irq #s as reported by the INTIDR register (used) */

#define DSC21_IRQ_TIMER0  0
#define DSC21_IRQ_TIMER1  1
#define DSC21_IRQ_TIMER2  2
#define DSC21_IRQ_TIMER3  3
#define DSC21_IRQ_CCDVD0  4
#define DSC21_IRQ_CCDVD1  5
#define DSC21_IRQ_CCDVD2  6
#define DSC21_IRQ_ENCVD   7
#define DSC21_IRQ_SERIAL0 8
#define DSC21_IRQ_SERIAL1 9
#define DSC21_IRQ_DSP     10
#define DSC21_IRQ_UART0   11
#define DSC21_IRQ_UART1   12
#define DSC21_IRQ_USB     13
#define DSC21_IRQ_BURST   14
#define DSC21_IRQ_CARD    15
#define DSC21_IRQ_EXB0    16
#define DSC21_IRQ_EXB1    17
#define DSC21_IRQ_EXB2    18
#define DSC21_IRQ_EXB3    19
#define DSC21_IRQ_EXB4    20
#define DSC21_IRQ_EXB5    21
#define DSC21_IRQ_EXB6    22
#define DSC21_IRQ_EXB7    23
#define DSC21_IRQ_DMA     24
#define DSC21_IRQ_FLASH   25
#define DSC21_IRQ_IRRX    26
#define DSC21_IRQ_IRTX    27

#define NR_IRQS           DSC21_IRQ_IRTX

/* alias */

#define IRQ_TIMER         DSC21_IRQ_TIMER0

/* flags for request_irq() */

#define IRQ_FLG_LOCK      (0x0001)  /* handler is not replaceable   */
#define IRQ_FLG_REPLACE   (0x0002)  /* replace existing handler     */
#define IRQ_FLG_FAST      (0x0004)
#define IRQ_FLG_SLOW      (0x0008)
#define IRQ_FLG_STD       (0x8000)  /* internally used              */

#endif /* __ASM_ARCH_IRQS_H__ */
