/**************************************************************************
 * linux/include/asm-armnommu/arch-dsc21/wdt_ioctl.h
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *	
 **************************************************************************/

#ifndef __ASM_ARCH_WDT_IOCTL_H
#define __ASM_ARCH_WDT_IOCTL_H

#include <linux/ioctl.h>

#define	WATCHDOG_IOCTL_BASE	'W'

/* The WDIOC_KEEPALIVE command will reset the watchdog timer to its
 * timeout value.  The timer must be reset periodically to keep the
 * watchdog timer from expiring. Any data accompanying the
 * WDIOC_KEEPALIVE command is ignored.
 */

#define	WDIOC_KEEPALIVE		_IOR(WATCHDOG_IOCTL_BASE, 0, int)

/* The WDIOC_SETTIMEOUT ioctl command will set the current timeout to
 * the specified timeout value.  The watchdog timer will be reset set to
 * this new timeout value immediately. This timeout value will also be
 * used on each time the watchdog is subsequently reset. The accompanyin
 *  data argument is interpreted as the new, unsigned timeout value in
 * microseconds.  The maximum,valid value for watchdog timeout value is
 * 353200 microseconds.
 */

#define	WDIOC_SETTIMEOUT        _IOW(WATCHDOG_IOCTL_BASE, 1, int)

/* The WDIOC_SETMODE  ioctl command will set the current watchdog mode
 * of operations to either interrupt the ARM or to RESET the ARM. The
 * accompanying data value must be either WDT_RESET_MODE or
 * WDT_INTERRUPT_MODE.
 */

#define	WDIOC_SETMODE           _IOW(WATCHDOG_IOCTL_BASE, 2, int)
#define WDT_RESET_MODE          0
#define WDT_INTERRUPT_MODE      1

#endif  /* __ASM_ARCH_WDT_IOCTL_H */
