/*
 * ItLpQueue.h
 * Copyright (C) 2001  Mike Corrigan IBM Corporation
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */








#ifndef _PPC_TYPES_H
#include <asm/types.h>
#endif
#include <asm/ptrace.h>


struct HvLpEvent;


#ifndef _ITLPQUEUE_H
#define _ITLPQUEUE_H

#define ITMaxLpQueues 8

#define NotUsed		0	
#define DedicatedIo	1	
#define DedicatedLp	2	
#define Shared		3	

#define LpEventStackSize 4096
#define LpEventMaxSize   256
#define LpEventAlign	 64

struct ItLpQueue
{
















	u8	xPlicOverflowIntPending;
	u8	xPlicStatus;		
	u16	xSlicLogicalProcIndex;	
	u8	xPlicRsvd[12];		
	char*	xSlicCurEventPtr;	
	char*	xSlicLastValidEventPtr;	
	char*	xSlicEventStackPtr;	
	u8	xIndex;			
	u8	xSlicRsvd[3];		
	u32	xInUseWord;		
	u64	xLpIntCount;		
	u64	xLpIntCountByType[9];	
};

extern struct ItLpQueue xItLpQueue;

extern struct HvLpEvent * ItLpQueue_getNextLpEvent( struct ItLpQueue * );
extern int ItLpQueue_isLpIntPending( struct ItLpQueue * ); 
extern unsigned ItLpQueue_process( struct ItLpQueue *, struct pt_regs * );
extern void ItLpQueue_clearValid( struct HvLpEvent * );

static __inline__ void process_iSeries_events( void )
{
	__asm__ __volatile__ (
	"	li	0,0x5555	\n\
		sc"
	: : : "r0", "r3" );	
}



#endif 
